class Compte_bancaire_ {
    constructor(id, solde) {
        this._id = id;
        this._solde = solde;
        this._cumul_interets;
    }

    static Information() {
        return "Classe générale des comptes bancaires";
    }

    id() {
        return this._id;
    }

    solde() {
        return this._solde;
    }

    cumul_interets() {
        return this._cumul_interets;
    }

    mise_a_jour(montant) {
        this._solde += montant;
        return this._solde;
    }

    taux_interet() {
        throw "Undefined function due to abstract nature of the class...";
    }

    appliquer_taux_interet() {
        this._cumul_interets = this._solde * (1. + (this.taux_interet() / 100.));
    }

    compareTo(cb) {
        return this._solde > cb._solde ? 1 : this._solde < cb._solde ? -1 : 0;
    }
}

class Compte_cheque_ extends Compte_bancaire_ {
    constructor(id, solde, taux_interet, seuil) {
        super(id, solde);
        this._taux_interet = taux_interet;
        this._seuil = seuil;
    }

    static Information() {
        return "Classe des comptes bancaires courants ou \"comptes chèque\" - rémunération à la tête du client !";
    }

    taux_interet() {
        return this._taux_interet;
    }

    appliquer_taux_interet() {
        if (this._solde > this._seuil) {
            super.appliquer_taux_interet();
        }
    }
}

console.log(Compte_bancaire_.Information());
let cb_ = null;
try {
    cb_ = new Compte_bancaire_("cb", 100.);
    cb_.appliquer_taux_interet(); // This fails since 'Compte_bancaire' is implemented as an abstract class...
    console.log(cb_.cumul_interets());
} catch (e) {
    console.log(e);
}
console.log(Compte_cheque_.Information());
cb_ = new Compte_cheque_("cc", 200., 0.02, 100.);
cb_.appliquer_taux_interet();
console.log(cb_.cumul_interets());
